Option Strict Off
Option Explicit On
Friend Class Form1
	Inherits System.Windows.Forms.Form
	'Set this to "1" if making an exe or "0" if debugging
	'(so that the full paths are included in the declare statements)
#Const EXE_BUILD = 1
	
#If EXE_BUILD Then
	Private Declare Function ECIO_GetDLLVersion Lib "ECIO_api.dll" () As Integer
    Private Declare Function ECIO_Open Lib "ECIO_api.dll" (ByVal index As Integer, ByRef pVID_PID As Byte) As Integer
	Private Declare Function ECIO_Close Lib "ECIO_api.dll" () As Integer
    Private Declare Function ECIO_Transmit Lib "ECIO_api.dll" (ByRef pDataOut As Byte, ByVal dwLenOut As Integer, ByRef pActualLenOut As Integer, ByRef pDataIn As Byte, ByVal dwExpectedLenIn As Integer, ByRef pActualLenIn As Integer, ByVal dwTimeout As Integer) As Integer
    Private Declare Function ECIO_GetDeviceCount Lib "ECIO_api.dll" (ByRef pVID_PID As Byte) As Integer
#Else
	Private Declare Function ECIO_GetDLLVersion Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" () As Long
	Private Declare Function ECIO_Open Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByVal index As Long, ByRef pVID_PID As Any) As Long
	Private Declare Function ECIO_Close Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" () As Long
	Private Declare Function ECIO_Transmit Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByRef pDataOut As Any, ByVal dwLenOut As Long, ByRef pActualLenOut As Long, ByRef pDataIn As Any, ByVal dwExpectedLenIn As Long, ByRef pActualLenIn As Long, ByVal dwTimeout As Long) As Long
	Private Declare Function ECIO_GetDeviceCount Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByRef pVID_PID As Any) As Long
#End If

    Declare Sub Sleep Lib "kernel32.dll" (ByVal milliseconds As Long)

    Private sID(0 To 20) As Byte
	
	Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		'Set the identifier
		sID(0) = Asc("v")
		sID(1) = Asc("i")
		sID(2) = Asc("d")
		sID(3) = Asc("_")
		sID(4) = Asc("1")
		sID(5) = Asc("2")
		sID(6) = Asc("b")
		sID(7) = Asc("f")
		sID(8) = Asc("&")
		sID(9) = Asc("p")
		sID(10) = Asc("i")
		sID(11) = Asc("d")
		sID(12) = Asc("_")
		sID(13) = Asc("0")
		sID(14) = Asc("2")
		sID(15) = Asc("1")
		sID(16) = Asc("0")
		sID(17) = 0
		
		Dim lRetVal As Integer
		lRetVal = ECIO_Open(0, sID(0))
		
        Dim bDataOut(0 To 2) As Byte
        Dim bDataIn(0 To 2) As Byte
		Dim nTxDataCnt As Integer
		Dim nRxDataCnt As Integer
		
        'Enable PWM Output Channel 1
        bDataOut(0) = 13 'PWM Control Command
        bDataOut(1) = 1 'Output To channel A (PWM 1)
        bDataOut(2) = 1 'Enable Channel
        lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)

        Timer1.Enabled = True
	End Sub
	
	Private Sub Form1_FormClosing(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
		Dim Cancel As Boolean = eventArgs.Cancel
		Dim UnloadMode As System.Windows.Forms.CloseReason = eventArgs.CloseReason
		
		Dim lRetVal As Integer
		Dim bDataOut(0 To 2) As Byte
		Dim bDataIn(0 To 2) As Byte
		Dim nTxDataCnt As Integer
		Dim nRxDataCnt As Integer
		
		'Change PWM Duty to 0
		bDataOut(0) = 14 'PWM Duty Control Command
		bDataOut(1) = 1 'Output To channel A (PWM 1)
		bDataOut(2) = 0 'Duty cycle off
		lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
		
		'Disable PWM Outputs
		bDataOut(0) = 13 'PWM Control Command
		bDataOut(1) = 1 'Output To channel A (PWM 1)
		bDataOut(2) = 0 'Disable Channel
		lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
		
		'Make sure the connection is closed
		ECIO_Close()
		eventArgs.Cancel = Cancel
	End Sub
	
	
	Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick
		
		Dim lRetVal As Integer
		Dim bDataOut(0 To 2) As Byte
		Dim bDataIn(0 To 2) As Byte
		Dim nTxDataCnt As Integer
		Dim nRxDataCnt As Integer
		
        Dim Setpoint As Integer
        Dim Sensor As Integer
        Dim Expected_Sensor As Integer
        Dim Error_Val As Integer
        Dim Out As Integer

        'Read Light Sensor
        bDataOut(0) = 3 'Analogue Input Command
        bDataOut(1) = 2 'Input Channel I2
        lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 200)
        Sensor = bDataIn(0)

        'Read Pot
        bDataOut(0) = 3 'Analogue Input Command
        bDataOut(1) = 1 'Input Channel I1
        lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 200)
        Setpoint = bDataIn(0)

        'Calculate the expected LDR value at this setpoint
        Expected_Sensor = (Setpoint / 12) + 33

        'Calculate the actual error
        Error_Val = Expected_Sensor - Sensor

        'Combine the setpoint and the error to get an output value
        Out = Setpoint + Error_Val

        'Ensure output value is between 0 and 255
        If (Out < 0) Then
            Out = 0
        End If
        If (Out > 255) Then
            Out = 255
        End If

        'Display the information
        ADC1.Text = CStr(Setpoint)
        ADC2.Text = CStr(Sensor)
        Expected_Val.Text = CStr(Expected_Sensor)
        Err_Val.Text = CStr(Error_Val)
        Lamp.Text = CStr(Out)

		'Update PWM Duty
		bDataOut(0) = 14 'PWM Duty Control Command
		bDataOut(1) = 1 'Output To channel A (PWM 1)
		bDataOut(2) = Out 'Duty cycle off
		lRetVal = ECIO_Transmit(bDataOut(0), 3, nTxDataCnt, bDataIn(0), 3, nRxDataCnt, 500)
		
	End Sub
End Class